/*
Copyright The KCP Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"

	v1alpha1 "github.com/kcp-dev/kcp/pkg/apis/tenancy/v1alpha1"
)

// FakeClusterWorkspaceShards implements ClusterWorkspaceShardInterface
type FakeClusterWorkspaceShards struct {
	Fake *FakeTenancyV1alpha1
}

var clusterworkspaceshardsResource = schema.GroupVersionResource{Group: "tenancy.kcp.dev", Version: "v1alpha1", Resource: "clusterworkspaceshards"}

var clusterworkspaceshardsKind = schema.GroupVersionKind{Group: "tenancy.kcp.dev", Version: "v1alpha1", Kind: "ClusterWorkspaceShard"}

// Get takes name of the clusterWorkspaceShard, and returns the corresponding clusterWorkspaceShard object, and an error if there is any.
func (c *FakeClusterWorkspaceShards) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.ClusterWorkspaceShard, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(clusterworkspaceshardsResource, name), &v1alpha1.ClusterWorkspaceShard{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ClusterWorkspaceShard), err
}

// List takes label and field selectors, and returns the list of ClusterWorkspaceShards that match those selectors.
func (c *FakeClusterWorkspaceShards) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.ClusterWorkspaceShardList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(clusterworkspaceshardsResource, clusterworkspaceshardsKind, opts), &v1alpha1.ClusterWorkspaceShardList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.ClusterWorkspaceShardList{ListMeta: obj.(*v1alpha1.ClusterWorkspaceShardList).ListMeta}
	for _, item := range obj.(*v1alpha1.ClusterWorkspaceShardList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested clusterWorkspaceShards.
func (c *FakeClusterWorkspaceShards) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(clusterworkspaceshardsResource, opts))
}

// Create takes the representation of a clusterWorkspaceShard and creates it.  Returns the server's representation of the clusterWorkspaceShard, and an error, if there is any.
func (c *FakeClusterWorkspaceShards) Create(ctx context.Context, clusterWorkspaceShard *v1alpha1.ClusterWorkspaceShard, opts v1.CreateOptions) (result *v1alpha1.ClusterWorkspaceShard, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(clusterworkspaceshardsResource, clusterWorkspaceShard), &v1alpha1.ClusterWorkspaceShard{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ClusterWorkspaceShard), err
}

// Update takes the representation of a clusterWorkspaceShard and updates it. Returns the server's representation of the clusterWorkspaceShard, and an error, if there is any.
func (c *FakeClusterWorkspaceShards) Update(ctx context.Context, clusterWorkspaceShard *v1alpha1.ClusterWorkspaceShard, opts v1.UpdateOptions) (result *v1alpha1.ClusterWorkspaceShard, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(clusterworkspaceshardsResource, clusterWorkspaceShard), &v1alpha1.ClusterWorkspaceShard{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ClusterWorkspaceShard), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeClusterWorkspaceShards) UpdateStatus(ctx context.Context, clusterWorkspaceShard *v1alpha1.ClusterWorkspaceShard, opts v1.UpdateOptions) (*v1alpha1.ClusterWorkspaceShard, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(clusterworkspaceshardsResource, "status", clusterWorkspaceShard), &v1alpha1.ClusterWorkspaceShard{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ClusterWorkspaceShard), err
}

// Delete takes name of the clusterWorkspaceShard and deletes it. Returns an error if one occurs.
func (c *FakeClusterWorkspaceShards) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(clusterworkspaceshardsResource, name, opts), &v1alpha1.ClusterWorkspaceShard{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeClusterWorkspaceShards) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(clusterworkspaceshardsResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.ClusterWorkspaceShardList{})
	return err
}

// Patch applies the patch and returns the patched clusterWorkspaceShard.
func (c *FakeClusterWorkspaceShards) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ClusterWorkspaceShard, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(clusterworkspaceshardsResource, name, pt, data, subresources...), &v1alpha1.ClusterWorkspaceShard{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ClusterWorkspaceShard), err
}
